package com.bergerkiller.bukkit.nolagg.examine;

import net.minecraft.server.WorldServer;

import org.bukkit.permissions.PermissionDefault;

import com.bergerkiller.bukkit.common.utils.WorldUtil;
import com.bergerkiller.bukkit.nolagg.base.NoLaggBase;

public class NoLaggExamine extends NoLaggBase {

	public static NoLaggExamine plugin;
	
	@Override
	public void enable() {
		plugin = this;
		for (WorldServer world : WorldUtil.getWorlds()) {
			TimedChunkProviderServer.convert(world);
		}
		this.register(new Commands());
		this.register(NLEListener.class);
		SchedulerWatcher.init();
	}

	@Override
	public void disable() {
		SchedulerWatcher.deinit();
		PluginLogger.stopTask();
		for (WorldServer world : WorldUtil.getWorlds()) {
			TimedChunkProviderServer.restore(world);
		}
	}

	@Override
	public void permissions() {
		this.loadPermission("nolagg.examine.run", PermissionDefault.OP, "Allows a player to examine the server");
	}

}
