package com.bergerkiller.bukkit.nolagg.examine;

public class TimedWrapper implements Runnable {
	
	public final Runnable runnable;
	private final TaskMeasurement dest;
	public TimedWrapper(final Runnable runnable, final TaskMeasurement dest) {
		this.runnable = runnable;
		this.dest = dest;
	}
		
	public void run() {
		if (PluginLogger.isRunning()) {
			long time = System.nanoTime();
			this.runnable.run();
			try {
				this.dest.setTime(time);
			} catch (ArrayIndexOutOfBoundsException ex) {}
		} else {
			this.runnable.run();
		}
	}
	
}
